include FilePad.inc

WndProc proc uses edi esi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
local hBitmap:DWORD
local rct:RECT
    .if uMsg==WM_CREATE
        invoke  GetMenu, hWnd                           ;   MENU STUFF
        mov     hMenu, eax
        invoke  LoadBitmap, hInstance, IDB_FONT
        mov     hBMFont, eax
        invoke  LoadBitmap, hInstance, IDB_ABOUT
        mov     hBMAbout, eax
        invoke  LoadBitmap, hInstance, IDB_PRINT
        mov     hBMPrint, eax
        invoke  LoadBitmap, hInstance, IDB_SAVE
        mov     hBMSave, eax
        invoke  LoadBitmap, hInstance, IDB_HELP
        mov     hBMHelp, eax
        invoke  LoadBitmap, hInstance, IDB_OPT
        mov     hBMOpt, eax
        invoke  LoadBitmap, hInstance, IDB_CLR
        mov     hBMClr, eax
        invoke  LoadBitmap, hInstance, IDB_CHK
        mov     hBMChk, eax
        invoke  LoadBitmap, hInstance, IDB_UNCHK
        mov     hBMUnChk, eax
        invoke  LoadBitmap, hInstance, IDB_CHKALL
        mov     hBMChkAll, eax
        invoke  LoadBitmap, hInstance, IDB_UNCHKALL
        mov     hBMUnChkAll, eax
        invoke  SetMenuItemBitmaps, hMenu, IDM_FONT_F, MF_BYCOMMAND, hBMFont, hBMFont
        invoke  SetMenuItemBitmaps, hMenu, IDM_FONT_I, MF_BYCOMMAND, hBMFont, hBMFont
        invoke  SetMenuItemBitmaps, hMenu, IDM_ABOUT, MF_BYCOMMAND, hBMAbout, hBMAbout
        invoke  SetMenuItemBitmaps, hMenu, IDM_PRINT, MF_BYCOMMAND, hBMPrint, hBMPrint
        invoke  SetMenuItemBitmaps, hMenu, IDM_SAVEAS, MF_BYCOMMAND, hBMSave, hBMSave
        invoke  SetMenuItemBitmaps, hMenu, IDM_HELP, MF_BYCOMMAND, hBMHelp, hBMHelp
        invoke  SetMenuItemBitmaps, hMenu, IDM_PREFS, MF_BYCOMMAND, hBMOpt, hBMOpt
        invoke  SetMenuItemBitmaps, hMenu, IDM_CLR_I, MF_BYCOMMAND, hBMClr, hBMClr
        invoke  SetMenuItemBitmaps, hMenu, IDM_CLR_F, MF_BYCOMMAND, hBMClr, hBMClr
        mov     cff.cbSize, sizeof CHARFORMAT           ;   FONT STUFF
        mov     cff.dwMask, CFM_BOLD or CFM_CHARSET or CFM_COLOR or CFM_FACE or CFM_ITALIC or CFM_OFFSET or CFM_SIZE or CFM_STRIKEOUT or CFM_UNDERLINE
        mov     cfi.cbSize, sizeof CHARFORMAT
        mov     cfi.dwMask, CFM_BOLD or CFM_CHARSET or CFM_COLOR or CFM_FACE or CFM_ITALIC or CFM_OFFSET or CFM_SIZE or CFM_STRIKEOUT or CFM_UNDERLINE
        invoke  xInitLogFont
        invoke  xCreateFont, addr hFF, addr lff, addr dwColorF, addr cff
        invoke  xCreateFont, addr hFI, addr lfi, addr dwColorI, addr cfi
        inc     fFnt
        invoke  GetClientRect, hWnd, addr rct           ;   SET WINDOW POSITIONS
        mov     dwW, 200
        invoke  CreateWindowEx, 0, addr TreeViewClass, NULL, \
                WS_CHILDWINDOW + WS_VISIBLE + TVS_HASLINES or TVS_SHOWSELALWAYS or WS_CLIPSIBLINGS or WS_BORDER or ES_SUNKEN, \
                0, 0, dwW, rct.bottom, hWnd, NULL, hInstance, NULL
        mov     hTV, eax
        sub     rct.right, 203
        invoke  CreateWindowEx, 0, addr RichEditClass, 0, WS_VISIBLE or WS_CHILDWINDOW or WS_CLIPSIBLINGS or ES_SUNKEN or \
                ES_MULTILINE or WS_VSCROLL or ES_NOHIDESEL or WS_HSCROLL or WS_BORDER, \
                203, 0, rct.right, rct.bottom, hWnd, 0, hInstance, NULL
        mov     hEdit, eax
        invoke  ImageList_Create, 16, 16, ILC_COLOR16, 9, 10    ;   IMAGELIST STUFF
        mov     hImageList, eax
        invoke  LoadBitmap, hInstance, IDB_TREE
        mov     hBitmap, eax
        invoke  ImageList_Add, hImageList, hBitmap, NULL
        invoke  DeleteObject, hBitmap
        invoke  SendMessage, hTV, TVM_SETIMAGELIST, TVSIL_NORMAL, hImageList    ;   TREEVIEW STUFF
        invoke  SetFocus, hTV
        invoke  xGetDrives  ;   set dwNDrives & bFixed
        invoke  xXpandFolder, hMC
        invoke  SendMessage, hTV, TVM_SELECTITEM, TVGN_CARET, hMC
    .elseif uMsg == WM_NOTIFY
        mov     edi, lParam


;===================================HERE
        szText  szMes, "EN_MSGFILTER"
        szText  szCap, "NMHDR"
        .if [edi].NMHDR.code == EN_MSGFILTER
            invoke  MessageBox, NULL, addr szMes, addr szCap, MB_OK
;===================================HERE


        .elseif [edi].NMTREEVIEW.hdr.code == TVN_SELCHANGED                 ;   tv select changed
            .if fSel            ;   flag: allow TVN_SELCHANGED processing?
                dec     fSel    ;   stop TVN_SELCHANGED processing
                mov     eax, hMC
                .if [edi].NMTREEVIEW.itemNew.hItem == eax                  ;   ROOT (MY COMPUTER) ?
                    inc     fSel    ;   allow TVN_SELCHANGED processing
                    ret
                .endif
                m2m     hTVCP, [edi].NMTREEVIEW.itemNew.hItem
                invoke  xGetDir, hTVCP
                invoke  xXpandFolder, hTVCP
                inc     fSel    ;   allow TVN_SELCHANGED processing
            .endif
        .elseif [edi].NMTREEVIEW.hdr.code == NM_CLICK                   ;   click
            dec     fSel        ;   stop TVN_SELCHANGED processing
            invoke	GetCursorPos, addr tvhit.pt
            invoke  ScreenToClient, hTV, addr tvhit.pt
            mov     tvhit.flags, TVHT_ONITEM
            invoke  SendMessage, hTV, TVM_HITTEST, 0, addr tvhit
            mov     hTVCP, eax
            invoke  SendMessage, hTV, TVM_EXPAND, TVE_TOGGLE, hTVCP         ;   TOGGLE TV EXPAND
            inc     fSel        ;   allow TVN_SELCHANGED processing
        .elseif [edi].NMTREEVIEW.hdr.code == NM_RCLICK                  ;   right click
            dec     fSel        ;   stop TVN_SELCHANGED processing
            invoke	GetCursorPos, addr tvhit.pt                             ;   FOLDER MARKING MENU
            invoke  ScreenToClient, hTV, addr tvhit.pt
            mov     tvhit.flags, TVHT_ONITEM
            invoke  SendMessage, hTV, TVM_HITTEST, 0, addr tvhit
            .if eax != hMC      ;   not root?
                .if eax         ;   not empty space?
                    mov     hTVCP, eax
                    invoke  SendMessage, hTV, TVM_SELECTITEM, TVGN_CARET, hTVCP
                    invoke  xGetDir, hTVCP
                    invoke  xXpandFolder, hTVCP
                    invoke	LoadMenu, hInstance, IDM_TREEMENU
                    invoke	GetSubMenu, eax, 0
                    mov		hpum, eax
                    invoke  SetMenuItemBitmaps, hpum, IDM_LIST, MF_BYCOMMAND, hBMChk, hBMChk
                    invoke  SetMenuItemBitmaps, hpum, IDM_UNLIST, MF_BYCOMMAND, hBMUnChk, hBMUnChk
                    invoke  SetMenuItemBitmaps, hpum, IDM_LISTALL, MF_BYCOMMAND, hBMChkAll, hBMChkAll
                    invoke  SetMenuItemBitmaps, hpum, IDM_UNLISTALL, MF_BYCOMMAND, hBMUnChkAll, hBMUnChkAll
                    invoke	GetCursorPos, addr mousePos
                    invoke	TrackPopupMenu, hpum, TPM_LEFTALIGN or TPM_RIGHTBUTTON, mousePos.x, mousePos.y, 0, hWnd, NULL
                    invoke	DestroyMenu, hpum
                .endif
            .endif
            inc     fSel        ;   allow TVN_SELCHANGED processing
        .endif
;  ======================================================================== ;    MESSAGES
    .elseif uMsg == WM_LBUTTONDOWN                                      ;    button down
        mov     SplitMove, TRUE                                             ;    BEGIN SPLIT_MOVE
        invoke  SetCapture, hWnd
    .elseif uMsg == WM_MOUSEMOVE                                        ;    mouse move
        .if SplitMove == TRUE
            invoke  GetClientRect, hWnd, addr rct
            mov     eax, lParam
            and     eax, 0ffffh
            mov     ecx, rct.right
            sub     ecx, 3
            .if eax > 0 && eax < ecx
                push    eax
                mov     dwW, eax
                dec     dwW
                invoke  MoveWindow , hTV, 0, rct.top, dwW, rct.bottom, TRUE
                pop     eax
                add     eax, 2
                sub     rct.right, eax
                invoke  MoveWindow , hEdit, eax, rct.top, rct.right, rct.bottom, TRUE
            .endif
        .endif
    .elseif uMsg == WM_LBUTTONUP                                        ;   left button up
        invoke  ReleaseCapture                                              ;   QUIT SPLIT_MOVE
        mov     SplitMove, FALSE
    .elseif uMsg == WM_SIZE                                             ;   size
        xor     edi, edi
        mov     eax, lParam
        mov     di, ax
        shr     eax, 16
        push    eax
        invoke  MoveWindow , hTV, 0, 0, dwW, eax, TRUE
        add     dwW, 3
        sub     edi, dwW
        pop     eax
        invoke  MoveWindow , hEdit, dwW, 0, edi, eax, TRUE
        sub     dwW, 3
    .elseif uMsg == WM_COMMAND                                          ;   COMMAND
        mov     eax, wParam
        and     eax, 0ffffh
        .if eax == IDM_PRINT                                            ;   Print...
            invoke  xPrint
        .elseif eax == IDM_CUT                                          ;   Cut
            invoke  SendMessage, hEdit, WM_CUT, 0, 0
        .elseif eax == IDM_COPY                                         ;   Copy
            invoke  SendMessage, hEdit, WM_COPY, 0, 0
        .elseif eax == IDM_PASTE                                        ;   Paste
            invoke  SendMessage, hEdit, WM_PASTE, 0, 0
        .elseif eax == IDM_DEL                                          ;   Delete
            invoke  SendMessage, hEdit, EM_REPLACESEL, TRUE, 0
        .elseif eax == IDM_ALL                                          ;   Select All
            invoke  SendMessage, hEdit, EM_SETSEL, 0, -1
        .elseif eax == IDM_LIST                                         ;   List
            invoke  xList
        .elseif eax == IDM_UNLIST                                       ;   UnList
            invoke  xUnList
        .elseif eax == IDM_LISTALL                                      ;   ListAll
            invoke  xMarkAll, 1
            invoke  xWrite
        .elseif eax == IDM_UNLISTALL                                    ;   UnListAll
            invoke  xMarkAll, 0
            invoke  xWrite
        .elseif eax == IDM_FONT_F                                       ;   set folder font
            invoke  xCreateFont, addr hFF, addr lff, addr dwColorF, addr cff
            invoke  xWrite
        .elseif eax == IDM_FONT_I                                       ;   set item font
            invoke  xCreateFont, addr hFI, addr lfi, addr dwColorI, addr cfi
            invoke  xWrite
        .elseif eax == IDM_CLR_I                                        ;   set item color
            invoke  xFontColor, addr dwColorI
            dec     fFnt
            invoke  xCreateFont, addr hFI, addr lfi, addr dwColorI, addr cfi
            inc     fFnt
            invoke  xWrite
        .elseif eax == IDM_CLR_F                                        ;   set Folder color
            invoke  xFontColor, addr dwColorF
            dec     fFnt
            invoke  xCreateFont, addr hFF, addr lff, addr dwColorF, addr cff
            inc     fFnt
            invoke  xWrite
        .elseif eax == IDM_PREFS                                        ;   Options...
            invoke  DialogBoxParam, hInstance, IDD_DLG_PREF, hWnd, addr xPrefDlgProc, NULL
        .elseif eax == IDM_SAVEAS                                       ;   saveas...
            invoke  xSaveas
        .endif
    .elseif uMsg == WM_DESTROY                                          ;   destroy
        invoke  DeleteObject, hBMFont
        invoke  DeleteObject, hBMAbout
        invoke  DeleteObject, hBMPrint
        invoke  DeleteObject, hBMSave
        invoke  DeleteObject, hBMHelp
        invoke  DeleteObject, hBMOpt
        invoke  DeleteObject, hBMClr
        invoke  DeleteObject, hBMChk
        invoke  DeleteObject, hBMUnChk
        invoke  DeleteObject, hBMChkAll
        invoke  DeleteObject, hBMUnChkAll
        invoke  DeleteObject, hFF
        invoke  DeleteObject, hFI
        invoke  ImageList_Destroy, hImageList
        invoke  PostQuitMessage, NULL
    .else                                                               ;   default
        invoke  DefWindowProc, hWnd, uMsg, wParam, lParam
        ret
    .endif
    xor     eax, eax
    ret
WndProc endp

end start
