.386
.model flat, stdcall
option casemap:none
include WINDOWS.Inc
include user32.inc
include kernel32.inc
include comctl32.inc
include gdi32.inc
include version.inc
include shlwapi.inc
include shell32.inc
include comdlg32.inc
include advapi32.inc
includelib user32.lib
includelib comctl32.lib
includelib kernel32.lib
includelib gdi32.lib
includelib version.lib
includelib shlwapi.lib
includelib shell32.lib
includelib comdlg32.lib
includelib advapi32.lib

m2m     MACRO   M1, M2
            push    M2
            pop     M1
endm

iabs    MACRO   arg:req, arg2:vararg
;       INTEGER ABSOLUTE
;   SYNTAX:     iabs    dwValue [, Destination]
local pos
        cmp		arg, 0
        jns		pos
        neg		arg
pos:    
        ifnb <arg2>
            m2m	arg2, arg
        endif
endm

szText  MACRO   name, Text:vararg
local   lbl
        jmp     lbl
name    db      Text, 0
lbl:
endm

IDM_MAINMENU    equ 10000
IDM_PRINT       equ 101
IDM_SAVEAS      equ 102
IDM_PREFS       equ 103
IDM_UNDO        equ 104
IDM_CUT         equ 105
IDM_COPY        equ 106
IDM_PASTE       equ 107
IDM_ALL         equ 108
IDM_DEL         equ 109
IDM_FONT_I      equ 4
IDM_FONT_F      equ 6
IDM_HELP        equ 5
IDM_ABOUT       equ 7
IDM_CLR_I       equ 8
IDM_CLR_F       equ 9
IDM_TREEMENU    equ 20000
IDM_LIST        equ 10
IDM_UNLIST      equ 11
IDM_CANCEL      equ 12
IDM_LISTALL     equ 13
IDM_UNLISTALL   equ 14
IDB_TREE        equ 4006
IDI_DC          equ 4010
IDB_ABOUT       equ 3000
IDB_FONT        equ 3001
IDB_PRINT       equ 3002
IDB_SAVE        equ 3003
IDB_HELP        equ 3008
IDB_CHK         equ 3004
IDB_UNCHK       equ 3005
IDB_CHKALL      equ 3006
IDB_UNCHKALL    equ 3007
IDB_OPT         equ 3009
IDB_CLR         equ 3010
IDD_DLG_PREF    equ 1001
IDC_CB_ITEM     equ 1003
IDC_CB_EXT      equ 1005
IDC_CB_FOLDER   equ 1002
IDC_CB_INC      equ 1008
IDC_COMBO       equ 1004
IDC_OK          equ 1006
IDC_CANCEL      equ 1007
IDC_REMOVE      equ 1009
IDC_CB_PATH     equ 1010
IDC_CB_LCI      equ 1011
IDC_CB_LCF      equ 1012
IDC_CB_UCI      equ 1013
IDC_CB_UCF      equ 1014
IDC_CB_US       equ 1015
DLG_ESCAPE      equ	0cf00h
DLG_RETURN      equ	0cf01h
IDA_ACCEL1      equ 100

WinMain         PROTO :DWORD, :DWORD, :DWORD, :DWORD
xCenterWnd      PROTO
xGetDrives      PROTO
xGetDir         PROTO :HANDLE
xXpandFolder    PROTO hCP:HANDLE
xPrint          PROTO
xInitLogFont    PROTO
xCreateFont     PROTO phFont:ptr HANDLE, pLF:ptr LOGFONT, pColor:ptr COLORREF, pChrFmt:ptr CHARFORMAT
xPrefDlgProc    PROTO hDlg:HANDLE, iMsg:DWORD, wParam:WPARAM, lParam:LPARAM
xAboutDlgProc   PROTO hDlg:HANDLE, iMsg:DWORD, wParam:WPARAM, lParam:LPARAM
xRegInit        PROTO
xMarkAll        PROTO fMark:DWORD
xWrite          PROTO 
xDoWriting      PROTO pTV:ptr TVITEM
xRegAdd         PROTO
xRegRemove      PROTO
xList           PROTO
xUnList         PROTO
xStreamOut      PROTO dwCookie:DWORD, pBuffer:DWORD, NumBytes:DWORD, pBytesTransferred:DWORD
xFontColor      PROTO pColor:ptr COLORREF

.data
ClassName       db "FilePad", 0
AppName         db "FilePad", 0
TreeViewClass   db "SysTreeView32", 0
RichEditClass   db "RICHEDIT20A", 0
RichEditDll     db "RichEd20.dll", 0
szMC            db "My Computer" , 0
szSDS           db "*.*", 0
szSD            db "*.", 0
szPDir          db "..", 0
szScheme        db "MyScheme", 0
SplitMove       dd 0
fSel            dd 1
szKey           db "Software\DCsoft\t2t", 0
szMP3           db "mp3", 0
szTXT           db "txt", 0
szJPG           db "jpg", 0
szBMP           db "bmp", 0
fEditChanged    dd 0
szFilter        db "Rich Text (*.rtf)", 0, "*.rtf", 0
                db "Word Doc (*.doc)", 0, "*.doc", 0
                db "All Files (*.*)", 0, "*.*", 0, 0
szDefExt        db "rtf"
                db 32 dup (0)
szInitDir       db "c:\My Documents"
                db 1000 dup (0)

;   PRINTER STUFF================================
szFont          db "MS Sans Serif", 0
dwColorF        dd 0
dwColorI        dd 0
mL              dd 360
mR              dd 360
mT              dd 360
mB              dd 302
;   FONT STUFF===================================
hFF             dd 0
hFI             dd 0
fFnt            dd 0
szlf            db 10, 0
szcr            db 13, 0
szTab           db "    ", 0
MyColors        dd 0, 444444h, 888888h, 0cccccch, 0ffffffh, 80ffh, 60c0h, 4080h
                dd 0ff0000h, 0cccc00h, 0ff00h, 0ffffh, 0ccffh, 0ffh, 0cc00ffh,0ff00cch
;   PREF STUFF===================================
dwCBI           dd 1
dwCBF           dd 1
dwCBE           dd 0
dwCBO           dd 0
dwCBP           dd 0
cbLCI           dd 0
cbLCF           dd 0
cbUCI           dd 0
cbUCF           dd 0
dwCBUS          dd 1
bExt            db "*.mp3"
                db 256 dup (0)
cbSel           dd 0
szUS            db "_", 0
szSpc           db " ", 0

.data?
hInstance       HINSTANCE ?
hwnd            HWND ?
hMenu           dd ?
hTV             dd ?
hTVCP           dd ?
hEdit           dd ?
hImageList      dd ?
hBMSave         dd ?
hBMHelp         dd ?
hBMAbout        dd ?
hBMPrint        dd ?
hBMFont         dd ?
hBMOpt          dd ?
hBMClr          dd ?
hBMChk          dd ?
hBMUnChk        dd ?
hBMChkAll       dd ?
hBMUnChkAll     dd ?
hMC             dd ?
hCombo          dd ?
hCBF            dd ?
hCBI            dd ?
hCBE            dd ?
hCBO            dd ?
hCBP            dd ?
hCBLCI          dd ?
hCBLCF          dd ?
hCBUCI          dd ?
hCBUCF          dd ?
hCBUS           dd ?
hAcc            dd ?
pBuf            dd ?
dwCX            dd ?
dwCY            dd ?
dwH             dd ?
dwW             dd ?
dwTBH           dd ?
nDrives         dd ?
bFixed          db 256 dup (?)
hDrives         dd 20 dup (?)
bExt2           db 100 dup (?)
finddata        WIN32_FIND_DATA <>
tvinsert        TV_INSERTSTRUCT <>
tvhit           TVHITTESTINFO <>
tvitem          TVITEM <>
buf             db 400h dup (?)
BufTo           db 1000 dup (?)
bFrom           db 1000 dup (?)
bTo             db 1000 dup (?)
bFileName       db 1000 dup (?)
AltFileName     db 256 dup(?)

mousePos		POINT	<>
hpum            dd ?
hFile           dd ?
hRichEditDLL    dd ?
cf              CHOOSEFONT <>
lff             LOGFONT <>
lfi             LOGFONT <>
cff             CHARFORMAT <>
cfi             CHARFORMAT <>
editstream      EDITSTREAM <>

.code
start:
	invoke  GetModuleHandle, NULL
	mov     hInstance, eax
    invoke  LoadAccelerators, hInstance, IDA_ACCEL1
    mov     hAcc, eax
	invoke  InitCommonControls
    invoke  LoadLibrary, addr RichEditDll
    mov     hRichEditDLL, eax
	invoke  WinMain, hInstance, NULL, NULL, SW_SHOWDEFAULT
    invoke  FreeLibrary, hRichEditDLL
	invoke  ExitProcess, eax

include Procs.inc